/*
* Modified From SimpleService by Apple.
*/

#import <Carbon/Carbon.h>
#import <string.h>

#import "ServiceTest.h"

OSStatus LaunchURL(const char *urlStr);

@implementation ServiceTest

/* This is an example of a service which doesn't return a value...
*/
- (void)doOpenFileService:(NSPasteboard *)pboard
 userData:(NSString *)data
 error:(NSString **)error
 {
    NSString *pboardString;
    NSArray *types;

    types = [pboard types];

    if (![types containsObject:NSStringPboardType] || !(pboardString = [pboard stringForType:NSStringPboardType])) {
        *error = NSLocalizedString(@"Error: Pasteboard doesn't contain a string.",
                   @"Pasteboard couldn't give string.");
        return;
    }

    LaunchURL([pboardString cString]);

    return;
}


@end

OSStatus LaunchURL(const char *urlStr)
{
    OSStatus err;
    ICInstance inst;
    long startSel;
    long endSel;

    err = ICStart (&inst, '????');           // Ǝ̃NG[^΂ɋL
    if (err == noErr) {
                if (err == noErr) {
                startSel = 0;
                endSel = strlen(urlStr);
                err = ICLaunchURL (inst, "\p", urlStr, 
                        endSel, &startSel, &endSel);
            }
        (void) ICStop (inst);
    }
    return (err);
}

